Index: orxonox/trunk/Makefile.in
===================================================================
--- orxonox/trunk/Makefile.in	(revision 3204)
+++ orxonox/trunk/Makefile.in	(revision 3205)
@@ -619,5 +619,5 @@
 \
 	$(DX_CONF_DIR)/progress						>> $(DX_CONFIG_FILE); \
-	if test $(DEBUG) = yes ; then \
+	if test $(DEBUG) -ge 2 ; then \
 	 echo "QUIET			= \"NO\""			>> $(DX_CONFIG_FILE); \
 	else \
Index: orxonox/trunk/config.h.in
===================================================================
--- orxonox/trunk/config.h.in	(revision 3204)
+++ orxonox/trunk/config.h.in	(revision 3205)
@@ -1,5 +1,5 @@
 /* config.h.in.  Generated from configure.ac by autoheader.  */
 
-/* if we ar in Debug Mode */
+/* in which debug mode we are */
 #undef DEBUG
 
Index: orxonox/trunk/configure
===================================================================
--- orxonox/trunk/configure	(revision 3204)
+++ orxonox/trunk/configure	(revision 3205)
@@ -865,6 +865,6 @@
   --disable-dependency-tracking  speeds up one-time build
   --enable-dependency-tracking   do not reject slow dependency extractors
-  --enable-debug          compiles GTK in debug mode. Lots of Debug info about
-                          the game
+  --enable-debug          compiles in debug mode. Lots of debug info about the
+                          game.
 
 Optional Packages:
@@ -3846,19 +3846,28 @@
 if test "${enable_debug+set}" = set; then
   enableval="$enable_debug"
-  DEBUG=yes
+  DEBUG=$enableval
 fi;
-echo "$DEBUG"
-if test "$DEBUG" = yes; then
+
+if test "$DEBUG" = "no"; then
+	echo "no"
+	echo " -> Setting debuglevel to 1. Like this you can still see errors."
+	DEBUG=1
+elif test "$DEBUG" = yes; then
+	echo "yes"
+	echo " -> Setting debuglevel to 3. HARD DEBUG MODE!!."
+	DEBUG=3
+else
+	echo "yes set to $DEBUG"
+fi
 
 cat >>confdefs.h <<_ACEOF
-#define DEBUG 1
-_ACEOF
-
-fi
+#define DEBUG $DEBUG
+_ACEOF
+
+
 
 
 
 ## GTK-disabled
-def_gtk=yes
 echo "$as_me:$LINENO: checking if gtk should be enabled" >&5
 echo $ECHO_N "checking if gtk should be enabled... $ECHO_C" >&6
@@ -3868,4 +3877,6 @@
   withval="$with_gtk"
   def_gtk=no
+else
+  def_gtk=yes
 fi;
 if test "$def_gtk" = yes; then
Index: orxonox/trunk/configure.ac
===================================================================
--- orxonox/trunk/configure.ac	(revision 3204)
+++ orxonox/trunk/configure.ac	(revision 3205)
@@ -26,19 +26,28 @@
 AC_MSG_CHECKING([if DEBUG-mode should be enabled])
 AC_ARG_ENABLE([debug], 
-	AC_HELP_STRING(	[--enable-debug], [compiles GTK in debug mode. Lots of Debug info about the game]),
-	 [DEBUG=yes]) 
-echo "$DEBUG"
-if test "$DEBUG" = yes; then 
-	AC_DEFINE_UNQUOTED(DEBUG, 1, [if we ar in Debug Mode])
-fi
+	AC_HELP_STRING(	[--enable-debug], [compiles in debug mode. Lots of debug info about the game.]),
+	 DEBUG=$enableval)
+
+if test "$DEBUG" = "no"; then 
+	echo "no"
+	echo " -> Setting debuglevel to 1. Like this you can still see errors."
+	DEBUG=1
+elif test "$DEBUG" = yes; then
+	echo "yes"
+	echo " -> Setting debuglevel to 3. HARD DEBUG MODE!!."
+	DEBUG=3
+else       
+	echo "yes set to $DEBUG"
+fi
+	AC_DEFINE_UNQUOTED(DEBUG, $DEBUG, [in which debug mode we are])
+
 AC_SUBST(DEBUG)
 
 
 ## GTK-disabled
-def_gtk=yes
 AC_MSG_CHECKING([if gtk should be enabled])
 AC_ARG_WITH([gtk], 
 	AC_HELP_STRING(	[--without-gtk], 
-	[Prevents GTK from being loaded]), [def_gtk=no]) 
+	[Prevents GTK from being loaded]), [def_gtk=no], [def_gtk=yes]) 
 if test "$def_gtk" = yes; then 
   echo "yes"
Index: orxonox/trunk/doc/documentation.am
===================================================================
--- orxonox/trunk/doc/documentation.am	(revision 3204)
+++ orxonox/trunk/doc/documentation.am	(revision 3205)
@@ -25,5 +25,5 @@
 \
 	$(DX_CONF_DIR)/progress						>> $(DX_CONFIG_FILE); \
-	if test $(DEBUG) = yes ; then \
+	if test $(DEBUG) -ge 2 ; then \
 	 echo "QUIET			= \"NO\""			>> $(DX_CONFIG_FILE); \
 	else \
Index: orxonox/trunk/src/debug.h
===================================================================
--- orxonox/trunk/src/debug.h	(revision 3204)
+++ orxonox/trunk/src/debug.h	(revision 3205)
@@ -3,10 +3,46 @@
 
 #ifdef  DEBUG
- #define PRINTF(x) \
-        if (verbose >= x ) \
-           printf ("%s:%d:", __FILE__, __LINE__); \
-        if (verbose >= x) printf
+#define PRINTF(x) \
+           PRINTF ## x
+
+#if DEBUG >= 1
+#define PRINTF1 \
+    if (verbose >= 1 ) \
+     printf ("%s:%d:", __FILE__, __LINE__); \
+     if (verbose >= 1) printf
+#else 
+#define PRINTF1
+#endif
+     
+#if DEBUG >= 2
+#define PRINTF2 \
+     if (verbose >= 2 ) \
+     printf ("%s:%d:", __FILE__, __LINE__); \
+     if (verbose >= 2) printf
+#else 
+#define PRINTF2
+#endif
+     
+#if DEBUG >= 3
+#define PRINTF3 \
+     if (verbose >= 3 ) \
+     printf ("%s:%d:", __FILE__, __LINE__); \
+     if (verbose >= 3) printf
+#else 
+#define PRINTF3
+#endif
+     
+#if DEBUG >= 4
+#define PRINTF4 \
+     if (verbose >= 4 ) \
+     printf ("%s:%d:", __FILE__, __LINE__); \
+     if (verbose >= 4) printf
+#else 
+#define PRINTF4
+#endif
+     
+     
 #else  
- #define PRINTF(x)
+#define PRINTF(x)
 #endif
 
Index: orxonox/trunk/src/importer/framework.cc
===================================================================
--- orxonox/trunk/src/importer/framework.cc	(revision 3204)
+++ orxonox/trunk/src/importer/framework.cc	(revision 3205)
@@ -51,7 +51,7 @@
 int main(int argc, char *argv[])
 {
-  int verbose = 2;
-
-  PRINTF(1)("This is The big verbose-Test %i, %s\n", 1, "cool");
+  int verbose = 3;
+
+  PRINTF(2)("This is The big verbose-Test %i, %s\n", 1, "cool");
 
   Uint8* keys; // This variable will be used in the keyboard routine