Index: code/branches/netp5/src/network/NetworkFunction.h
===================================================================
--- code/branches/netp5/src/network/NetworkFunction.h	(revision 3210)
+++ code/branches/netp5/src/network/NetworkFunction.h	(revision 3211)
@@ -33,4 +33,5 @@
 
 #include <cassert>
+#include <cstring>
 #include <map>
 #include <string>
Index: code/branches/netp5/src/network/NetworkPrereqs.h
===================================================================
--- code/branches/netp5/src/network/NetworkPrereqs.h	(revision 3210)
+++ code/branches/netp5/src/network/NetworkPrereqs.h	(revision 3211)
@@ -129,14 +129,14 @@
     class Packet;
     class Welcome;
-  }
 
-  namespace PacketFlag
-  {
-    enum Enum
+    namespace PacketFlag
     {
-      Reliable   = 1,
-      Unsequence = 2,
-      NoAllocate = 4
-    };
+      enum Enum
+      {
+        Reliable   = 1,
+        Unsequence = 2,
+        NoAllocate = 4
+      };
+    }
   }
 }
Index: code/branches/netp5/src/network/packet/Chat.cc
===================================================================
--- code/branches/netp5/src/network/packet/Chat.cc	(revision 3210)
+++ code/branches/netp5/src/network/packet/Chat.cc	(revision 3211)
@@ -29,4 +29,5 @@
 #include "Chat.h"
 
+#include <cstring>
 #include <string>
 #include "network/Host.h"
Index: code/branches/netp5/src/network/packet/ClassID.cc
===================================================================
--- code/branches/netp5/src/network/packet/ClassID.cc	(revision 3210)
+++ code/branches/netp5/src/network/packet/ClassID.cc	(revision 3211)
@@ -30,4 +30,6 @@
 
 #include <cassert>
+#include <cstdlib>
+#include <cstring>
 #include <map>
 #include <queue>
Index: code/branches/netp5/src/network/packet/FunctionCalls.cc
===================================================================
--- code/branches/netp5/src/network/packet/FunctionCalls.cc	(revision 3210)
+++ code/branches/netp5/src/network/packet/FunctionCalls.cc	(revision 3211)
@@ -30,4 +30,5 @@
 
 #include <cassert>
+#include <cstring>
 #include "util/MultiType.h"
 #include "network/NetworkFunction.h"
Index: code/branches/netp5/src/network/packet/FunctionIDs.cc
===================================================================
--- code/branches/netp5/src/network/packet/FunctionIDs.cc	(revision 3210)
+++ code/branches/netp5/src/network/packet/FunctionIDs.cc	(revision 3211)
@@ -30,4 +30,5 @@
 
 #include <cassert>
+#include <cstring>
 #include <queue>
 #include <string>
Index: code/branches/netp5/src/network/packet/Gamestate.h
===================================================================
--- code/branches/netp5/src/network/packet/Gamestate.h	(revision 3210)
+++ code/branches/netp5/src/network/packet/Gamestate.h	(revision 3211)
@@ -34,4 +34,5 @@
 
 #include <cassert>
+#include <cstring>
 #include <list>
 
Index: code/branches/netp5/src/network/packet/Packet.cc
===================================================================
--- code/branches/netp5/src/network/packet/Packet.cc	(revision 3210)
+++ code/branches/netp5/src/network/packet/Packet.cc	(revision 3211)
@@ -31,4 +31,5 @@
 
 #include <cassert>
+#include <cstring>
 #include <enet/enet.h>
 #include <boost/static_assert.hpp>
Index: code/branches/netp5/src/network/synchronisable/Synchronisable.cc
===================================================================
--- code/branches/netp5/src/network/synchronisable/Synchronisable.cc	(revision 3210)
+++ code/branches/netp5/src/network/synchronisable/Synchronisable.cc	(revision 3211)
@@ -31,4 +31,5 @@
 #include "Synchronisable.h"
 
+#include <cstdlib>
 #include "core/CoreIncludes.h"
 #include "core/BaseObject.h"
Index: code/branches/netp5/src/network/synchronisable/Synchronisable.h
===================================================================
--- code/branches/netp5/src/network/synchronisable/Synchronisable.h	(revision 3210)
+++ code/branches/netp5/src/network/synchronisable/Synchronisable.h	(revision 3211)
@@ -33,4 +33,5 @@
 
 #include <cassert>
+#include <cstring>
 #include <vector>
 #include <map>
Index: code/branches/netp5/src/network/synchronisable/SynchronisableVariable.h
===================================================================
--- code/branches/netp5/src/network/synchronisable/SynchronisableVariable.h	(revision 3210)
+++ code/branches/netp5/src/network/synchronisable/SynchronisableVariable.h	(revision 3211)
@@ -34,4 +34,5 @@
 
 #include <cassert>
+#include <cstring>
 #include "util/Serialise.h"
 #include "core/GameMode.h"